unit uMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Samples.Spin, Vcl.StdCtrls, Vcl.Buttons;

type TadjencyListElement=^AdjencyListElement;

   AdjencyListElement=record

   vertex:integer; // number of adjency vertex
   weight:integer;
   next:TadjencyListElement; // pointer to next vertex

end;


type
  TMain = class(TForm)
    MemoTest: TMemo;
    bAddEdge: TBitBtn;
    seVertex1: TSpinEdit;
    seVertex2: TSpinEdit;
    Vertex1: TLabel;
    Vertex2: TLabel;
    bRemoveEdge: TBitBtn;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure bAddEdgeClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }

    function addEdge(AVertex1, AVertex2:integer):boolean;
    {will add to the end of adjency list or will create a first element if empty or nil }

    procedure deleteEdge(AFirstAdjencyListElement,ADeletedAdjencyListElement:TadjencyListElement);
    {< will delete in adjency list ADeletedAdjencyListElement }

    function  searchByVertex(AFirstAdjencyListElement:TadjencyListElement; AVertex:integer):TadjencyListElement;
    {< will search in adjency list an AdjencyListElement (edge) with vertex=AVertex  }

    procedure clearMemory();

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

const N=10;
var
  Main: TMain;
  Graph:Array [1..N] of TadjencyListElement;

implementation

{$R *.dfm}

{ TMain }

function TMain.addEdge(AVertex1, AVertex2:integer):boolean;

var newAdjencyListElement:TadjencyListElement;
    tempAdjencyListElement:TadjencyListElement;

begin
result:=false;
// will insert edge beetwen vertex x and vertex y

 if Graph[AVertex1]<>nil then begin // if list in x vertex already sterted, add to the end of adjency list

  if searchByVertex( Graph[AVertex1],AVertex2)=nil then begin // if no such vertex

  New(newAdjencyListElement);
  newAdjencyListElement.vertex:=AVertex2;
  newAdjencyListElement.next:=nil;

  tempAdjencyListElement:=Graph[AVertex1];
  while tempAdjencyListElement^.Next<>nil do
  tempAdjencyListElement:=tempAdjencyListElement^.next; // now tempAdjencyListElement is the last in adjency list

  tempAdjencyListElement^.next:=newAdjencyListElement; // now it points to the last added adjency element
  result:=True;
  end;

 end else

 begin  // creating first new element of adjency list

    New(newAdjencyListElement);
    newAdjencyListElement^.vertex:=AVertex2;
    newAdjencyListElement^.next:=nil;
    Graph[AVertex1]:=newAdjencyListElement;
 result:=True;
 end;


end;



procedure TMain.bAddEdgeClick(Sender: TObject);
begin
if addEdge(seVertex1.Value,seVertex2.Value) then
MemoTest.Lines.Add('v1='+seVertex1.Value.ToString()+' '+'v2='+seVertex2.Value.ToString());
end;

procedure TMain.clearMemory;
var
  i: Integer;
begin
 for i := 0 to High(Graph) do if Graph[i]<>nil then  Dispose(TadjencyListElement(Graph[i]));
end;

constructor TMain.Create(AOwner: TComponent);
var
  i: Integer;
begin
  inherited;
for i := 0 to High(Graph) do Graph[i]:=nil;

end;

procedure TMain.deleteEdge(AFirstAdjencyListElement,ADeletedAdjencyListElement:TadjencyListElement);
var tempAdjencyListElement:TadjencyListElement;
    beforeDeletedAdjencyListElement:TadjencyListElement;

begin

// case 1 element in adjency list
 if  (AFirstAdjencyListElement.next=nil) and (ADeletedAdjencyListElement=AFirstAdjencyListElement) then
dispose(ADeletedAdjencyListElement)

else

// case deleted element is first
if AFirstAdjencyListElement=ADeletedAdjencyListElement then begin
//AFirstAdjencyListElement:=AFirstAdjencyListElement.next;
dispose(ADeletedAdjencyListElement)
end

 else

 begin

  // search for element before deleted
  tempAdjencyListElement:=AFirstAdjencyListElement;
  while tempAdjencyListElement<>ADeletedAdjencyListElement do
  begin
  beforeDeletedAdjencyListElement:=tempAdjencyListElement;
  tempAdjencyListElement:=tempAdjencyListElement.next;
  end;

  //change links
  if ADeletedAdjencyListElement.next<>nil then  // if not last element
  beforeDeletedAdjencyListElement.next:=ADeletedAdjencyListElement.next else
  beforeDeletedAdjencyListElement.next:=nil;

  //delete
  dispose(ADeletedAdjencyListElement);

 end;


end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
ReportMemoryLeaksOnShutdown:=true;
clearMemory();
end;

function TMain.searchByVertex(AFirstAdjencyListElement: TadjencyListElement; AVertex: integer):TadjencyListElement;
var tempAdjencyListElement:TadjencyListElement;
begin
Result:=nil;

tempAdjencyListElement:=AFirstAdjencyListElement;

  repeat
    if tempAdjencyListElement.vertex=AVertex then
    begin
    Result:=tempAdjencyListElement;
    Break;
    end;
  tempAdjencyListElement:=tempAdjencyListElement.next;
  until tempAdjencyListElement=nil;

end;

end.
